#include <fstream>
#include <iostream>

std::ifstream fin("librarie.in");
std::ofstream fout("librarie.out");

const int maxn = 100000;

struct Operatie {
  int stanga;
  int dreapta;
  int delta;
};

int main() {
  int n;
  fin >> n;

  long long prices[100001];
  for (int i = 1; i <= n; i++) {
    fin >> prices[i];
  }

  int zile;
  fin >> zile;

  Operatie history[maxn];
  int history_size = 0;
  int current_pos = 0;

  for (int k = 0; k < zile; k++) {
    int t;
    fin >> t;

    for (int i = 0; i < t; i++) {
      char op;
      fin >> op;

      if (op == '+' || op == '-') {
        int L, R, num;
        fin >> L >> R >> num;
        int delta = (op == '+') ? num : -num;

        history_size = current_pos;

        for (int j = L; j <= R; j++) {
          prices[j] += delta;
        }

        history[history_size] = {L, R, delta};
        history_size++;
        current_pos = history_size;
      } else if (op == 'u') {
        if (current_pos > 0) {
          current_pos--;
          Operatie last = history[current_pos];

          for (int j = last.stanga; j <= last.dreapta; j++) {
            prices[j] -= last.delta;
          }
        }
      } else if (op == 'r') {
        if (current_pos < history_size) {
          Operatie next = history[current_pos];

          for (int j = next.stanga; j <= next.dreapta; j++) {
            prices[j] += next.delta;
          }

          current_pos++;
        }
      }
    }

    for (int i = 1; i <= n; i++) {
      fout << prices[i];
      if (i < n)
        fout << " ";
      else
        fout << "\n";
    }
  }

  return 0;
}
