#include <fstream>
#include <iostream>

std::ifstream fin("librarie.in");
std::ofstream fout("librarie.out");

const int maxn = 100000;

int main() {
  int n;
  fin >> n;

  long long current_prices[100001];
  for (int i = 1; i <= n; i++) {
    fin >> current_prices[i];
  }

  int zile;
  fin >> zile;

  int appliedL[maxn], appliedR[maxn], appliedDelta[maxn];
  int undoneL[maxn], undoneR[maxn], undoneDelta[maxn];
  int appliedSize = 0, undoneSize = 0;

  for (int k = 0; k < zile; k++) {
    int t;
    fin >> t;
    for (int i = 0; i < t; i++) {
      char op;
      fin >> op;

      if (op == '+' || op == '-') {
        int L, R, num;
        fin >> L >> R >> num;
        int delta = (op == '+') ? num : -num;

        for (int j = L; j <= R; j++) {
          current_prices[j] += delta;
        }

        appliedL[appliedSize] = L;
        appliedR[appliedSize] = R;
        appliedDelta[appliedSize] = delta;
        appliedSize++;

      } else if (op == 'u') {
        if (appliedSize > 0) {
          appliedSize--;
          int lastL = appliedL[appliedSize];
          int lastR = appliedR[appliedSize];
          int lastDelta = appliedDelta[appliedSize];

          for (int j = lastL; j <= lastR; j++) {
            current_prices[j] -= lastDelta;
          }

          undoneL[undoneSize] = lastL;
          undoneR[undoneSize] = lastR;
          undoneDelta[undoneSize] = lastDelta;
          undoneSize++;
        }
      } else if (op == 'r') {
        if (undoneSize > 0) {
          undoneSize--;
          int lastL = undoneL[undoneSize];
          int lastR = undoneR[undoneSize];
          int lastDelta = undoneDelta[undoneSize];

          for (int j = lastL; j <= lastR; j++) {
            current_prices[j] += lastDelta;
          }

          appliedL[appliedSize] = lastL;
          appliedR[appliedSize] = lastR;
          appliedDelta[appliedSize] = lastDelta;
          appliedSize++;
        }
      }
    }

    for (int i = 1; i <= n; i++) {
      fout << current_prices[i];
      if (i < n)
        fout << " ";
      else
        fout << "\n";
    }
  }

  return 0;
}
