#include <fstream>
#include <iostream>

std::ifstream fin("librarie.in");
std::ofstream fout("librarie.out");

const int maxn = 100000;

struct Operatie {
  int stanga;
  int dreapta;
  int delta;
};

int main() {
  int n;
  fin >> n;

  long long prices[100001];
  long long diff[100002] = {0};

  for (int i = 1; i <= n; i++) {
    fin >> prices[i];
  }

  int zile;
  fin >> zile;

  Operatie history[maxn];
  int history_size = 0;
  int current_pos = 0;

  for (int k = 0; k < zile; k++) {
    int t;
    fin >> t;

    for (int i = 0; i < t; i++) {
      char op;
      fin >> op;

      if (op == '+' || op == '-') {
        int L, R, num;
        fin >> L >> R >> num;
        int delta = (op == '+') ? num : -num;

        diff[L] += delta;
        diff[R + 1] -= delta;

        history[current_pos] = {L, R, delta};
        current_pos++;

        if (current_pos > history_size) {
          history_size = current_pos;
        }
      } else if (op == 'u') {
        if (current_pos > 0) {
          current_pos--;
          Operatie last = history[current_pos];

          diff[last.stanga] -= last.delta;
          diff[last.dreapta + 1] += last.delta;
        }
      } else if (op == 'r') {
        if (current_pos < history_size) {
          Operatie next = history[current_pos];

          diff[next.stanga] += next.delta;
          diff[next.dreapta + 1] -= next.delta;

          current_pos++;
        }
      }
    }

    long long prefix_sum = 0;
    for (int i = 1; i <= n; i++) {
      prefix_sum += diff[i];
      long long current_price = prices[i] + prefix_sum;

      fout << current_price;
      if (i < n)
        fout << " ";
      else
        fout << "\n";
    }
  }

  return 0;
}
