#include <assert.h>

#include <fstream>
#include <stack>
#include <vector>

using namespace std;

ifstream fin("librarie.in");
ofstream fout("librarie.out");

const int NMAX = 1e5 + 1;
int pr[NMAX];

struct op {
  char c;
  int x, y, val;

  op(char c, int x, int y, int val) : c(c), x(x), y(y), val(val) {}
};

int main() {
  int n, q;
  fin >> n;
  assert(n < NMAX);
  assert(n >= 1);
  for (int i = 1; i <= n; ++i) {
    fin >> pr[i];
    assert(pr[i] >= 0);
    assert(pr[i] <= 1e9);
  }

  fin >> q;
  assert(q <= 100);
  int t, x, y, val;
  stack<op> u, r;
  char c;

  while (q--) {
    vector<int> mars(n + 1, 0);
    fin >> t;
    assert(t < NMAX);
    while (t--) {
      fin >> c;
      assert(c == '+' || c == '-' || c == 'u' || c == 'r');
      if (c == '+' || c == '-') {
        fin >> x >> y >> val;
        assert(x <= y);
        assert(x >= 1);
        assert(y <= n);
        assert(val <= 10000);
        if (c == '+') {
          mars[x] += val;
          mars[y + 1] -= val;
          u.push(op('-', x, y, val));
        } else {
          mars[x] -= val;
          mars[y + 1] += val;
          u.push(op('+', x, y, val));
        }
      } else if (c == 'u') {
        if (!u.empty()) {
          op crt = u.top();
          u.pop();
          if (crt.c == '+') {
            mars[crt.x] += crt.val;
            mars[crt.y + 1] -= crt.val;
          } else {
            mars[crt.x] -= crt.val;
            mars[crt.y + 1] += crt.val;
          }
          r.push({crt.c == '+' ? '-' : '+', crt.x, crt.y, crt.val});
        }
      } else {
        if (!r.empty()) {
          op crt = r.top();
          r.pop();
          if (crt.c == '+') {
            mars[crt.x] += crt.val;
            mars[crt.y + 1] -= crt.val;
          } else {
            mars[crt.x] -= crt.val;
            mars[crt.y + 1] += crt.val;
          }
          u.push({crt.c == '+' ? '-' : '+', crt.x, crt.y, crt.val});
        }
      }
    }
    for (int i = 1; i <= n; ++i) {
      mars[i] += mars[i - 1];
      pr[i] += mars[i];
      fout << pr[i] << ' ';
    }
    fout << '\n';
  }

  return 0;
}
